Package org.apache.commons.collections4.set

# Class PredicatedSet<E>

java.lang.Object
org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
org.apache.commons.collections4.collection.PredicatedCollection<E>
org.apache.commons.collections4.set.PredicatedSet<E>

Type Parameters:
  `E` - The type of the elements in this set

All Implemented Interfaces:
  `Serializable`, `Iterable<E>`, `Collection<E>`, `Set<E>`

Direct Known Subclasses:
  `PredicatedSortedSet`

public class PredicatedSet<E> extends PredicatedCollection<E> implements Set<E>
Decorates another `Set` to validate that all additions match a specified predicate.

This set exists to provide validation for the decorated set. It is normally created to decorate an empty set. If an object cannot be added to the set, an IllegalArgumentException is thrown.

One usage would be to ensure that no null entries are added to the set.

    Set set = PredicatedSet.decorate(new HashSet(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  3.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `PredicatedCollection.Builder<E>`

- ## Field Summary

  ### Fields inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `predicate`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `PredicatedSet(Set<E> set, Predicate<? super E> predicate)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Set<E>`
  `decorated()`
  Gets the set being decorated.
  `boolean`
  `equals(Object object)`
  `int`
  `hashCode()`
  `static <E> PredicatedSet<E>`
  `predicatedSet(Set<E> set, Predicate<? super E> predicate)`
  Factory method to create a predicated (validating) set.

  ### Methods inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `add, addAll, builder, notNullBuilder, predicatedCollection, validate`

  ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

  `clear, contains, containsAll, isEmpty, iterator, remove, removeAll, removeIf, retainAll, setCollection, size, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Collection

  `parallelStream, removeIf, stream`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface java.util.Set

  `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, spliterator, toArray, toArray`

- ## Constructor Details

  - ### PredicatedSet

    protected PredicatedSet(Set<E> set, Predicate<? super E> predicate)
    Constructor that wraps (not copies).

    If there are any elements already in the set being decorated, they are validated.

    Parameters:
      `set` - The set to decorate, must not be null
      `predicate` - The predicate to use for validation, must not be null
    Throws:
      `NullPointerException` - if set or predicate is null
      `IllegalArgumentException` - if the set contains invalid elements

- ## Method Details

  - ### predicatedSet

    public static <E> PredicatedSet<E> predicatedSet(Set<E> set, Predicate<? super E> predicate)
    Factory method to create a predicated (validating) set.

    If there are any elements already in the set being decorated, they are validated.

    Type Parameters:
      `E` - The element type
    Parameters:
      `set` - The set to decorate, must not be null
      `predicate` - The predicate to use for validation, must not be null
    Returns:
      A decorated set
    Throws:
      `NullPointerException` - if set or predicate is null
      `IllegalArgumentException` - if the set contains invalid elements
    Since:
      4.0

  - ### decorated

    protected Set<E> decorated()
    Gets the set being decorated.
    Overrides:
      `decorated` in class `AbstractCollectionDecorator<E>`
    Returns:
      The decorated set

  - ### equals

    public boolean equals(Object object)
    Specified by:
      `equals` in interface `Collection<E>`
    Specified by:
      `equals` in interface `Set<E>`
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Specified by:
      `hashCode` in interface `Collection<E>`
    Specified by:
      `hashCode` in interface `Set<E>`
    Overrides:
      `hashCode` in class `Object`